from gpaw.dipole_correction import DipoleCorrection
from gpaw.mixer import Mixer, MixerSum, MixerDif
import numpy as np
from math import pi
from ase.constraints import FixAtoms
from ase.io import write, read
from gpaw.poisson import PoissonSolver
from gpaw import GPAW, FermiDirac, Mixer, MixerSum
from ase.optimize import BFGS
from ase.lattice.surface import *
from ase.structure import molecule
from ase.lattice.surface import add_adsorbate, fcc111
import sys
from sys import argv
from gpaw.utilities import h2gpts


name = sys.argv[1]
slab = read(name)
label = name[:-5] + '-re'

slab.pbc=(True,True,False)

#for i in slab:                                                                                                                             
 #   print(i)                                                                                                                               
  #  if i.symbol == 'Ru':                                                                                                                   
   #     i.magmom=0.1                                                                                                                       
#sys.exit()                                                                                                                                 
#mnum=1.23                                                                                                                                  
#slab[30].magmom = mnum                                                                                                                    
#slab[23].magmom = -1*mnum                                                                                                                 
#slab[36].magmom = mnum                                                                                                                    
#slab[43].magmom = -1*mnum                                                                                                                                                                                                           

poissonsolver = PoissonSolver()
correction = DipoleCorrection(poissonsolver,2)

calc = GPAW(h=0.20,
            occupations=FermiDirac(0.1),
            kpts = (3,2,1),
            #spinpol=True,                                                                                                                
            #mixer=MixerDif(0.02,3,weight=100), #for spinpol calc                                                                         
            #mode='lcao',                                                                                                                 
            basis='dzp',                                                                                                                  
            maxiter = 1500,
            poissonsolver =correction,
            xc = 'RPBE',
            txt=label + '.txt')

slab.set_calculator(calc)
dyn=BFGS(slab,
         trajectory=label + '.traj',
         logfile=label + '.log')                                                                                                          
dyn.run(fmax=0.05)
calc.write(label + ".gpw")
