#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""

@author: adrian
"""

import matplotlib.pyplot as plt
import numpy as np
from matplotlib.ticker import MultipleLocator








########mixed_Ir_Ru#####
s1 = [
      'AC2',#' conv (Ru)',
      
      'AC2',#' alt (Ru)',
      'AC4',#' alt (Ru)',
      #'AC6',# alt (Ru)',
      'A4',#' alt (Ru)',
      
      'AC1',#' (Ni-Ni)',
      'ABC1',#' (Ni-Ni)',
      
      'A1',#' (Ni-Ru)',
      'AC3',#' (Ni-Ru)',
      'BC1',#' (Ru-Ni)',
      'BC3',#' (Ni-Ru)',
      'ABC3',#' (Ni-Ru)',
      'ABD1',#' (Ni-Ru)',
      'ACD3',#' (Ni-Ru)'
      
      'BCD8']# Popout
###########################

s=s1

a=np.linspace(0.3,1,len(s1)*2)

colors = ['r','g','mediumspringgreen','b','coral','m','gray','plum','olive','yellow','c','deeppink','crimson','salmon','peru','y','purple','brown','tomato','indigo','lightpink','r','indigo','mediumspringgreen','b','b']



########### Data here / binding energies straight from dft ############
E_OH_list = np.array([
                      0.829831, # AC2 conv Ru

                      -0.245049, # AC2 alt
                      0.225167, # AC4 alt
                      #0.226480, # AC6 alt
                      0.515792, # A4 alt Ru

                      0.595331, # AC1 Ni-Ni
                      0.742635, # ABC1 Ni-Ni
                      
                      0.105037, # A1 Ni-Ru
                      0.128866, # AC3 Ni-Ru
                      0.115345, # BC1 Ru-Ni
                      -0.092358, # BC3 Ru-Ni
                      0.036433, # ABC3 Ni-Ru
                      0.139294, # ABD1 Ni-Ru
                      0.395731, # ACD3 Ni-Ru
                      
                      0.066347 # BCD8 popout
                      ])

E_O_list = np.array([
                     1.790591,# AC2 conv Ru

                     1.790591, # AC2 alt
                     1.749761,# AC4 alt
                     #1.759258,# AC6 alt
                     1.634911,# A4 alt Ru

                     2.630971,# AC1 Ni-Ni
                     2.769684,# ABC1 Ni-Ni
                     
                     1.477753,# A1 Ni-Ru
                     1.653460,# AC3 Ni-Ru
                     1.647536,# BC1 Ru-Ni
                     1.475546,# BC3 Ru-Ni
                     1.733595,# ABC3 Ni-Ru
                     1.662053, # ABD1 Ni-Ru
                     1.766636,# ACD3 Ni-Ru
                     
                     1.319746 #BCD8 popout
                     ])

E_OOH_list = np.array([
                       3.944304,# AC2 conv Ru

                       2.871676,# AC2 alt
                       3.126454,# AC4 alt
                       #3.133325,# AC6 alt
                       3.396865,# A4 alt Ru

                       3.778134,# AC1 Ni-Ni
                       3.811284,# ABC1 Ni-Ni
                       
                       3.396829,# A1 Ni-Ru
                       3.401812,# AC3 Ni-Ru
                       3.356168,# BC1 Ru-Ni
                       3.543158,# BC3 Ru-Ni
                       3.560991,# ABC3 Ni-Ru
                       3.388311,# ABD1 Ni-Ru
                       3.371626,# ACD3 Ni-Ru
                       
                       3.564677 # BCD8 popout
                       ])


G_OH_list = E_OH_list + 0.35
G_O_list = E_O_list + 0.05
G_OOH_list = E_OOH_list + 0.4


fig, (ax2) = plt.subplots(figsize=(6, 6), ncols=1)
lw=4
al=0.7
## IDEAL ###                                                                                           
U=0
G_O2 = 4.92 - 4 * U
G_OOH = 1.23 - 1 * U
G_O = 1.23 - 1 * U
G_OH = 1.23 - 1 * U
G_H2O = 1.23 - 1 * U
G_H2O2 = 3.54


############################
# VOLCANO
############################
G_OH = np.arange(-10,10,0.1)
ax2.plot(G_OH,G_OH,color='k',ls='-',zorder=-10)
ax2.plot(G_OH,1.72-G_OH,color='k',ls='-',zorder=-10)
ax2.plot(G_OH,3.2-G_OH,color='k',ls='-',zorder=-10)
#ax2.set_title('Yb$_2$Ir$_2$O$_7$')
ax2.axhline(1.6,color='k',ls=':',alpha=al)
ax2.axhline(1.23,color='k',ls='--',alpha=al,zorder=-10)
ax2.axhline(0.86,color='k',ls=':',alpha=al)
ax2.text(2.8,1.25,'$1.23$ eV',fontsize=11)
ax2.text(2.8,1.62,'$1.60$ eV',fontsize=11)
ax2.text(2.8,0.88,'$0.86$ eV',fontsize=11)
ax2.text(0.65,0.20,'ORR',fontsize=20,alpha=0.5)
ax2.text(1.37,2.25,'OER',fontsize=20,alpha=0.5)


U=[]
# metal G_O G_OH G_OOH min
print('%s\t\t\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s'%('Metal','G_OH','G_O','G_OOH','G4','G3','G2','G1','U','volc'))
for i in range(0,len(G_O_list)):
    print('%s\t\t\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f\t%0.2f'%(s[i],
                                            G_OH_list[i],
                                            G_O_list[i],
                                            G_OOH_list[i],
                                            4.92-G_OOH_list[i],
                                            G_OOH_list[i]-G_O_list[i],
                                            G_O_list[i]-G_OH_list[i],
                                            G_OH_list[i],
                                            np.max(np.array([4.92-G_OOH_list[i],G_OOH_list[i]-G_O_list[i],G_O_list[i]-G_OH_list[i],G_OH_list[i]])),
                                            1.72-G_OH_list[i]
                                        ))
    U.append(np.max(np.array([4.92-G_OOH_list[i],G_OOH_list[i]-G_O_list[i],G_O_list[i]-G_OH_list[i],G_OH_list[i]])))

ms=120
al=0.7
mark='o'
mark1='s'


for i in range(len(G_O_list))[:30]:
    ax2.scatter(G_O_list[i]-G_OH_list[i],U[i],color=colors[i],s=ms,edgecolor='k',marker=mark,label=r'%s'%s[i],alpha=al,zorder=1)

ax2.scatter(1.23,1.23, marker = (5,1),s=ms+50,edgecolor='k',color='yellow', label='Ideal catalyst')
ax2.scatter(1.6,1.6, marker = (5,1),s=ms+50,edgecolor='k',color='red', label='Optimal catalyst')


ax2.text(0.3,0.33, r'$\rm \Delta G$$_{1,2}$', fontsize=12,bbox=dict(facecolor='white', edgecolor='none', boxstyle='round,pad=0.2'),rotation=45)
ax2.text(1.1,0.4, r'$\rm \Delta G$$_4$', fontsize=12,bbox=dict(facecolor='white', edgecolor='none', boxstyle='round,pad=0.2'),rotation=-45)
ax2.text(2.54,0.44, r'$\rm \Delta G$$_3$', fontsize=12,bbox=dict(facecolor='white', edgecolor='none', boxstyle='round,pad=0.2'),rotation=-45)


ax2.annotate(text='', xy=(2.3,1.23), xytext=(2.3,2.3), arrowprops=dict(arrowstyle='<->'))
ax2.text(2.3,1.8,r'$\eta$$_{\rm OER}$',fontsize=14,rotation=-90)







# Print text atop the figure


ax2.set_xlabel(r'G$_{\rm O*}-$G$_{\rm HO*}$ [eV]',fontsize=14)
ax2.set_ylabel('U [V]',fontsize=14)
ax2.legend(loc=1,ncol=1,bbox_to_anchor = [1,1],fontsize=8.3,scatterpoints=1, framealpha = 1)
ax2.set_xlim([0,3.2])
ax2.set_ylim([0,3])
ax2.yaxis.set_minor_locator(MultipleLocator(0.25))
ax2.xaxis.set_minor_locator(MultipleLocator(0.25))

fig.savefig('volcano.pdf')




## OER-only volcano


def ov_pot(x):
    return -(x - 1.23)

G_OH = np.arange(-10,10,0.1)

alternate_calc  = [1,2,3]
NiNi_site = [4,5]
ref_calc = [0]

for f in range(len(G_O_list)+1):
    fig, ax = plt.subplots(figsize=(8,6))
    plt.plot(G_OH,ov_pot(G_OH),color='blue',ls='-',zorder=-10)
    #plt.plot(G_OH,ov_pot(1.72-G_OH),color='k',ls='-',zorder=-10)
    plt.plot(G_OH,ov_pot(3.2-G_OH),color='red',ls='-',zorder=-10)

    plt.scatter(1.24,-0.55,color=colors[-4],s=ms,edgecolor='k',marker='s',alpha=al,zorder=1,label='IrO$_2$ (110)')

    for i in range(len(G_O_list))[:f]:
        
        # Choose marker
        
        if i in alternate_calc:
            mark = 'p'
        elif i in NiNi_site:
            mark = '*'
        elif i in ref_calc:
            mark = 's'
        elif i == len(G_O_list) - 1:
            mark = '^'
        else:
            mark = 'o'
        
        eta = -(U[i]-1.23)
        plt.scatter(G_O_list[i]-G_OH_list[i],eta,color=colors[i],s=ms,edgecolor='k',marker=mark,label=r'%s'%s[i],alpha=al,zorder=1)

    plt.title('OER Volcanoplot for Ru$_{1-x}$Ni$_x$O$_2$')
    plt.xlabel(r'G$_{\rm O*}-$G$_{\rm HO*}$ [eV]', fontsize = 14)
    plt.ylabel("$-\eta$ [V]", fontsize = 14)
    plt.xlim([0.6,2.2])
    plt.ylim([-1.4,-0.3])
    first_legend = plt.legend(loc = 'lower right')
    ax.annotate(' ■   Reference\n ⬟   Ru pathway\n ★   Ni-Ni site\n ●   Ru-Ni site\n ▲   Popout',
                (1.81,-0.63), xytext=(20,20), size=10,
                textcoords='offset points',
                bbox={'facecolor':'white',
                      'edgecolor':'gray',
                      'boxstyle':'round',
                      'alpha': 0.5  })
    #plt.legend(bbox_to_anchor=(1.3, 0.7))
    fig.savefig('./workingdirectory/Ni-volcano'+str(f)+'.png')


####################################################################################

# Ti volcano plot


TiTi_list = [1,3,5]
RuRu_list = [7]
s = ["AC3","ABC1","ABC3","ACD1","ACD3","ACE1","BCD1","BDF1"]

E_OH_list = np.array([
                      -0.3172970, #AC3
                      -0.1095810, #ABC1
                      -0.1486880, #ABC3
                       0.0656420, #ACD1
                      -0.2160850, #ACD3
                       0.1936380, #ACE1
                      -0.5046020, #BCD1
                      -0.4786610, #BDF1

                      ])

E_O_list = np.array([
                     1.1858970, #AC3
                     1.1937030, #ABC1
                     1.4351720, #ABC3
                     1.2035890, #ACD1
                     1.4522520, #ACD3
                     1.7209900, #ACE1
                     1.2849840, #BCD1
                     1.2006800, #BDF1

                     ])

E_OOH_list = np.array([
                       3.1694300, #AC3
                       3.3533680, #ABC1
                       3.3331930, #ABC3
                       3.6665360, #ACD1
                       3.1812310, #ACD3
                       3.7983990, #ACE1
                       2.8888040, #BCD1
                       2.7694790, #BDF1

                       ])


G_OH_list = E_OH_list + 0.35
G_O_list = E_O_list + 0.05
G_OOH_list = E_OOH_list + 0.4


for f in [0]:
    fig, ax1 = plt.subplots(figsize=(8,6))
    plt.plot(G_OH,ov_pot(G_OH),color='blue',ls='-',zorder=-10)
    plt.plot(G_OH,ov_pot(3.2-G_OH),color='red',ls='-',zorder=-10)

    plt.scatter(1.24,-0.55,color=colors[-4],s=ms,edgecolor='k',marker='s',alpha=al,zorder=1,label='IrO$_2$ (110)')

    for i in range(len(G_O_list)):
        
        # Choose marker
        if i in TiTi_list:
            mark = '*'
        elif i in RuRu_list:
            mark = '^'
        else:
            mark = 'o'
        
        U = np.max(np.array([4.92-G_OOH_list[i],G_OOH_list[i]-G_O_list[i],G_O_list[i]-G_OH_list[i],G_OH_list[i]]))
        
        eta = -(U-1.23)
        plt.scatter(G_O_list[i]-G_OH_list[i],eta,color=colors[i],s=ms,edgecolor='k',marker=mark,label=r'%s'%s[i],alpha=al,zorder=1)

    plt.title('OER Volcanoplot for Ru$_{1-x}$Ti$_x$O$_2$')
    plt.xlabel(r'G$_{\rm O*}-$G$_{\rm HO*}$ [eV]', fontsize = 14)
    plt.ylabel("$-\eta$ [V]", fontsize = 14)
    plt.xlim([0.6,1.8])
    plt.ylim([-1.7,-0.3])
    first_legend = plt.legend(loc = 'lower right')
    ax1.annotate(' ■   Reference   \n ★   Ti-Ti site\n ●   Ru-Ti site\n ▲   Ru-Ru site',
                (1.51,-1.11),
                xytext=(20,20), size=10,
                textcoords='offset points',
                bbox={'facecolor':'white',
                      'edgecolor':'gray',
                      'boxstyle':'round',
                      'alpha': 0.5
                      })
    fig.savefig('./workingdirectory/Ti-volcano.png')











